/*********************
callbacks.c           
	by logotherapy
*********************/
#include "callbacks.h"



/*********************
VARIABLE       
*********************/
// character
static gboolean gb_user_shift;
extern GtkWidget *character_t; // text
extern GtkWidget *user_key_t; // table
extern GtkWidget *user_tb; // toggle button
extern GtkWidget *user_b; // button
extern key_ts key[];
extern gint gi_total_key;
extern gint gi_shift;
extern gint gi_current_lang;

// text
extern GtkWidget *text_sb; // spin button
extern GtkObject *text_a; // adjustment
extern GtkWidget *text_log_l; // label
extern GtkWidget *text_log_c; // clock
extern GtkWidget *text_t[]; // text
extern GtkWidget *text_e[]; // entry
extern GtkWidget *text_l[]; // label
extern GtkWidget *text_c[]; // clock
extern GString *gs_text[];
extern gint gi_total_line;
extern gint gi_current_line;

// game
extern game_ts game[];



/*********************
character callbacks
*********************/
void user_b_clicked (GtkButton *button, gpointer user_data)
{
	FILE *fp;
	gint gi_dog;

	fp = fopen ("./keys/User", "w");
	if(fp)
    {
		for (gi_dog=0;gi_dog<gi_total_key;gi_dog++)
   			fprintf(fp, "%s %s\n", key[gi_dog].lang[1].v, key[gi_dog].lang[1].w);
		fclose(fp);
	}
}



void user_tb_toggled (GtkToggleButton *togglebutton, gpointer user_data)
{
	gint gi_dog;
	gb_user_shift = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (togglebutton)); 

	for (gi_dog = 0; gi_dog < gi_total_key; gi_dog++)
    {
		if (gb_user_shift == TRUE)
   			gtk_entry_set_text (GTK_ENTRY (key[gi_dog].e), key[gi_dog].lang[1].w);
		else 
			gtk_entry_set_text (GTK_ENTRY (key[gi_dog].e), key[gi_dog].lang[1].v);
	}
}



void user_e_changed (GtkEditable *editable, key_ts *gp_key)
{
	if (gb_user_shift == TRUE)
		sprintf (gp_key->lang[1].w, "%s", gtk_entry_get_text (GTK_ENTRY (editable)) );
	else 
		sprintf (gp_key->lang[1].v, "%s", gtk_entry_get_text (GTK_ENTRY (editable)) );

	key_release_shift();
}



void lang_mi_activate (GtkMenuItem *menuitem, gint gi_lang)
{
	gi_current_lang = gi_lang;
	if (gi_current_lang == 1)
	{
		gtk_widget_show (user_key_t);
		gtk_widget_show (user_tb);
		gtk_widget_show (user_b);
	}
	else 
	{
		gtk_widget_hide (user_key_t);
		gtk_widget_hide (user_tb);
		gtk_widget_hide (user_b);
	}
	key_release_shift();
}



void key_b_button_press_event (GtkButton *button, GdkEventButton *event, key_ts *gp_key)
{
    GtkStyle *keyboard_s;
	gchar gc_vw[GTYPING_VW_LENGTH];

    keyboard_s = gtk_style_new ();
    keyboard_s->bg[0].red = 30000;
	gtk_widget_set_style (GTK_WIDGET (button), keyboard_s);

	if (gp_key->flag == GTYPING_KEYS)
	{
		if (gi_shift != GTYPING_OFF_SHIFT)
			sprintf(gc_vw, "%s", gp_key->lang[gi_current_lang].w);
		else if (event!=NULL)
		{
			if (event->button==3)
				sprintf(gc_vw, "%s", gp_key->lang[gi_current_lang].w);
			else
				sprintf(gc_vw, "%s", gp_key->lang[gi_current_lang].v);
		}
		else 
			sprintf(gc_vw, "%s", gp_key->lang[gi_current_lang].v);
		gtk_text_insert (GTK_TEXT (character_t), NULL, NULL, NULL, gc_vw, 2);
	}
	else if (gp_key->flag == GTYPING_SPACE)
		gtk_text_insert (GTK_TEXT (character_t), NULL, NULL, NULL, " ", 1);
	else if (gp_key->flag == GTYPING_BACKSPACE)
		gtk_text_backward_delete (GTK_TEXT (character_t), 1);
	else if (gp_key->flag == GTYPING_RETURN)
		gtk_text_insert (GTK_TEXT (character_t), NULL, NULL, NULL, "\n", 1);
}



void key_b_button_release_event (GtkButton *button, GdkEventButton *event, key_ts *gp_key)
{
	gtk_widget_set_style (GTK_WIDGET (button), gtk_widget_get_default_style ());
}





/*********************
text callbacks
*********************/
void text_e_insert_text (GtkEditable *editable, gchar *new_text, gint new_text_length, gint *position, gpointer user_data)
{
	GdkColor correct_dc; // gdk color
	GdkColor incorrect_dc; // gdk color
	gchar *gc_t;
	gchar *gc_fox, gc_dog[8];
	gint gi_dog = GPOINTER_TO_INT (user_data);
	gint gi_position = *position;

	correct_dc.red = 0xffff;
	correct_dc.green = 0;
	correct_dc.blue = 0;

	incorrect_dc.red = 0xffff;
	incorrect_dc.green = 0;
	incorrect_dc.blue = 0;

	if (new_text_length!=0)
	{
	
	if (gs_text[gi_current_line+gi_dog]->len >= gi_position+new_text_length)
	{
		gc_t = gtk_editable_get_chars (GTK_EDITABLE (text_t[gi_dog]), gi_position, gi_position+new_text_length);
		new_text[new_text_length]=0;

		if (!strcmp (gc_t, new_text))
		{
			gtk_text_set_point (GTK_TEXT (text_t[gi_dog]), gi_position);
			gtk_text_forward_delete (GTK_TEXT (text_t[gi_dog]), new_text_length);

			gtk_text_insert (GTK_TEXT (text_t[gi_dog]), NULL, &correct_dc, NULL, gc_t, new_text_length);

			if (gs_text[gi_current_line+gi_dog]->len == gi_position+new_text_length)
			{
				gtk_label_get (GTK_LABEL (text_log_l), &gc_fox);
				sprintf (gc_dog, "%d", gs_text[gi_current_line+gi_dog]->len+atoi(gc_fox));
				gtk_label_set (GTK_LABEL (text_log_l), gc_dog);

				gtk_clock_set_seconds (GTK_CLOCK (text_log_c), 
					(GTK_CLOCK (text_log_c)->tm->tm_min * 60) + GTK_CLOCK (text_log_c)->tm->tm_sec+
					(GTK_CLOCK (text_c[gi_dog])->tm->tm_min * 60) + GTK_CLOCK (text_c[gi_dog])->tm->tm_sec);
				
				if (gi_dog==GTYPING_TEXT_PAGE-1)
				{
					gtk_spin_button_set_value (GTK_SPIN_BUTTON (text_sb), gi_current_line+=GTYPING_TEXT_PAGE);
					text_te_init ();
					gtk_widget_grab_focus (text_e[0]);
					gtk_clock_start(GTK_CLOCK (text_c[0]));
				}
				else
				{
					gtk_clock_stop(GTK_CLOCK (text_c[gi_dog]));
					gtk_widget_grab_focus (text_e[gi_dog+1]);
					gtk_clock_start (GTK_CLOCK (text_c[gi_dog+1]));
				}
			}
		}
		else
		{
			gtk_text_set_point (GTK_TEXT (text_t[gi_dog]), gi_position);
			gtk_text_forward_delete (GTK_TEXT (text_t[gi_dog]), new_text_length);

			gtk_text_insert (GTK_TEXT (text_t[gi_dog]), NULL, NULL, &incorrect_dc, gc_t, new_text_length);
		}
	}

	}
}



void text_e_delete_text (GtkEditable *editable, gint start_pos, gint end_pos, gpointer user_data)
{
	gint gi_dog = GPOINTER_TO_INT (user_data);
	gchar *gc_t;

	if (gs_text[gi_current_line+gi_dog]->len >= end_pos)
	{
		gc_t = gtk_editable_get_chars (GTK_EDITABLE (text_t[gi_dog]), start_pos, end_pos);
		gtk_text_set_point (GTK_TEXT (text_t[gi_dog]), start_pos);
		gtk_text_forward_delete (GTK_TEXT (text_t[gi_dog]), end_pos-start_pos);
		gtk_text_insert (GTK_TEXT (text_t[gi_dog]), NULL, NULL, NULL, gc_t, end_pos-start_pos);
	}
}



void text_gfp_font_set (GnomeFontPicker *gnomefontpicker, gchar *font_name, gpointer user_data)
{
	GtkRequisition text_r; // requisition
    GtkStyle *text_t_s; // style
    GtkStyle *text_e_s; // style
	gint gi_dog;

	for (gi_dog=0;gi_dog<GTYPING_TEXT_PAGE;gi_dog++)
	{
		text_e_s = gtk_style_new ();
		text_e_s->font = gdk_fontset_load (font_name);
		gtk_widget_set_style (GTK_WIDGET (text_e[gi_dog]), text_e_s);

		text_t_s = gtk_widget_get_style (text_t[gi_dog]);
		text_e_s->base[0] = text_t_s->base[0];
		gtk_widget_set_style (GTK_WIDGET (text_t[gi_dog]), text_e_s);

		gtk_widget_size_request (text_e[gi_dog], &text_r);
		gtk_widget_set_usize (text_t[gi_dog], text_r.width, text_r.height);
	}
}



void text_a_value_changed (GtkWidget *widget, gpointer user_data)
{
	gint gi_sb;
	gi_sb = gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (user_data));
	if (gi_sb != CLAMP(gi_sb, gi_current_line, gi_current_line+4))
	{
		if (gi_sb<gi_total_line)
		{
			gi_current_line = gi_sb;
			text_te_init ();
			gtk_clock_start(GTK_CLOCK (text_c[0]));
		}
	}
}



void text_ce_activate (GtkEditable *editable, gpointer user_data)
{
	FILE *fp;
	gchar gc_c;
	gboolean gb_still_blank = TRUE;

	gi_total_line = 0;
	gs_text[gi_total_line] = g_string_new ("");
	
	if ( (fp = fopen (gtk_entry_get_text (GTK_ENTRY (editable)), "r"))  !=  NULL) {
		while (1) {
			gc_c = fgetc(fp);
			if (gc_c != EOF)
			{
				if (gc_c=='\n')
			   	{
					if (gs_text[gi_total_line]->len >=1)
					{	
						gi_total_line++;
						if (gi_total_line==GTYPING_TEXT_LINE_MAX) break;
						gs_text[gi_total_line] = g_string_new ("");
					}
					gb_still_blank = TRUE;
				}
				else if (gc_c==' ')
				{
					if (gb_still_blank==FALSE)
						gs_text[gi_total_line] = g_string_append_c (gs_text[gi_total_line], gc_c);
				}
				else if (gc_c!='\t')
				{
					gb_still_blank = FALSE;
					gs_text[gi_total_line] = g_string_append_c (gs_text[gi_total_line], gc_c);
				}
			}
			else break;
		}
		GTK_ADJUSTMENT (text_a)->lower = 0;
		GTK_ADJUSTMENT (text_a)->upper = gi_total_line-1;
		GTK_ADJUSTMENT (text_a)->step_increment = 1;
		GTK_ADJUSTMENT (text_a)->page_increment = GTYPING_TEXT_PAGE;
		gi_current_line = 0;
		gtk_adjustment_set_value (GTK_ADJUSTMENT (text_a), gi_current_line);
		text_te_init ();

		gtk_label_set (GTK_LABEL (text_log_l), "");
		gtk_clock_set_seconds (GTK_CLOCK (text_log_c), 0);

		gtk_widget_grab_focus (text_e[0]);
		gtk_clock_start(GTK_CLOCK (text_c[0]));
	}
	else return;
}





/*********************
game callbacks
*********************/
void game_e_activate (GtkEditable *editable, gpointer user_data)
{
	gint gi_dog;

	for (gi_dog=0;gi_dog<GTYPING_GAME_UNIT;gi_dog++)
	{
		if (!strcmp (game[gi_dog].text, gtk_entry_get_text (GTK_ENTRY (editable)) ))
		{
			switch (game[gi_dog].state)
			{
				case GTYPING_STOP:
					game[gi_dog].state = GTYPING_MOVE;
					break;

				case GTYPING_MOVE:
					game[gi_dog].state = GTYPING_STOP;	
					break;
			}
			break;
		}
	}

	gtk_entry_set_text (GTK_ENTRY (editable), "");
}



/*********************
main callbacks
*********************/
gboolean main_w_delete_event (GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
	gtk_main_quit ();
	return FALSE;
}



gboolean main_w_key_press_event (GtkWidget *widget, GdkEventKey *event, gpointer user_data)
{
    gint gi_dog;

	if (!event->keyval) return TRUE;

	if (gi_shift == GDK_Shift_L)
		if (event->keyval == GDK_Shift_R) return TRUE;
	if (gi_shift == GDK_Shift_R)
		if (event->keyval == GDK_Shift_L) return TRUE;

	if (event->state & GDK_SHIFT_MASK)
	{
		for (gi_dog = 0;  gi_dog < gi_total_key;  gi_dog++)
			if(!strcmp(key[gi_dog].m, gdk_keyval_name (event->keyval)))
				key_b_button_press_event (GTK_BUTTON (key[gi_dog].b), NULL, &key[gi_dog]);
	}
	else
	{	
		for (gi_dog = 0;  gi_dog < gi_total_key;  gi_dog++)
			if(!strcmp(key[gi_dog].n, gdk_keyval_name (event->keyval)))
				key_b_button_press_event (GTK_BUTTON (key[gi_dog].b), NULL, &key[gi_dog]);
	}

	switch (event->keyval) {
		case GDK_Shift_L:
		case GDK_Shift_R:
			gi_shift = event->keyval;
			key_press_shift();
			break;
	}

	return FALSE;
}



gboolean main_w_key_release_event (GtkWidget *widget, GdkEventKey *event, gpointer user_data)
{
    gint gi_dog;

	if (!event->keyval) return TRUE;

	if (gi_shift == GDK_Shift_L)
		if (event->keyval == GDK_Shift_R) return TRUE;
	if (gi_shift == GDK_Shift_R)
		if (event->keyval == GDK_Shift_L) return TRUE;

	if (event->state & GDK_SHIFT_MASK)
	{
		for (gi_dog = 0;  gi_dog < gi_total_key;  gi_dog++)
			if(!strcmp(key[gi_dog].m, gdk_keyval_name (event->keyval)))
				key_b_button_release_event (GTK_BUTTON (key[gi_dog].b), NULL, &key[gi_dog]);
	}
	else {
		for (gi_dog = 0;  gi_dog < gi_total_key;  gi_dog++)
			if(!strcmp(key[gi_dog].n, gdk_keyval_name (event->keyval)))
				key_b_button_release_event (GTK_BUTTON (key[gi_dog].b), NULL, &key[gi_dog]);
	}

	switch (event->keyval) {
		case GDK_Shift_L:
		case GDK_Shift_R:
			gi_shift = GTYPING_OFF_SHIFT;
			key_release_shift();
			break;
	}
    return FALSE;
}
