/*********************
character.c                
	by logotherapy
*********************/
#include "callbacks.h"



/*********************
GLOBAL VARIABLE       
*********************/
static GtkWidget *keyboard_t;	// table
GtkWidget *user_key_t; // table
GtkWidget *user_tb; // toggle button
GtkWidget *user_b; // button
GtkWidget *character_t; // text
key_ts key[GTYPING_KEYS_MAX];
gint gi_total_key = 0;
gint gi_shift = GTYPING_OFF_SHIFT;
gint gi_current_lang = 0;



void key_load_file ()
{
	FILE *fp;
	gint gi_flag;

    fp = fopen ("./keys/Main", "r");
    if(fp)
	{
		while (TRUE)
		{
			if ( fscanf(fp, "%d ", &gi_flag)  ==  EOF ) break;
			key[gi_total_key].flag = gi_flag;
            fscanf(fp, "%d %d %d %d %s %s\n",
				   &key[gi_total_key].left, &key[gi_total_key].right, &key[gi_total_key].top, &key[gi_total_key].bottom,
				   key[gi_total_key].n, key[gi_total_key].m);
			gi_total_key++;
		}
		fclose(fp);
    }
}



void key_load_lang (gchar *gc_lang_f, gint gi_lang)
{
	FILE *fp;
	gint gi_dog;

    fp = fopen (gc_lang_f, "r");
    if(fp)
	{
		for (gi_dog=0;gi_dog<gi_total_key;gi_dog++)
			fscanf(fp, "%s %s\n", key[gi_dog].lang[gi_lang].v, key[gi_dog].lang[gi_lang].w);
		fclose(fp);
    }
}



void key_init (GtkStyle *keyboard_s)
{
	gint gi_dog;

	for (gi_dog = 0;  gi_dog < gi_total_key;  gi_dog++)
	{
		key[gi_dog].b = gtk_button_new ();
	   	gtk_table_attach_defaults (GTK_TABLE (keyboard_t), key[gi_dog].b,
			key[gi_dog].left, key[gi_dog].right, key[gi_dog].top, key[gi_dog].bottom);
		gtk_widget_set_style (GTK_WIDGET (key[gi_dog].b), gtk_widget_get_default_style ());
		GTK_WIDGET_UNSET_FLAGS (GTK_WIDGET (key[gi_dog].b), GTK_CAN_FOCUS);
		gtk_signal_connect (GTK_OBJECT (key[gi_dog].b), "button_press_event", GTK_SIGNAL_FUNC (key_b_button_press_event), &key[gi_dog]);
		gtk_signal_connect (GTK_OBJECT (key[gi_dog].b), "button_release_event", GTK_SIGNAL_FUNC (key_b_button_release_event), &key[gi_dog]);

		key[gi_dog].l = gtk_label_new(key[gi_dog].lang[gi_current_lang].v);
		gtk_container_add (GTK_CONTAINER (key[gi_dog].b), key[gi_dog].l);
		gtk_widget_set_style (key[gi_dog].l, keyboard_s);
	}
}



void key_set_user_key (GtkWidget *conf_f)
{
	gint gi_dog;

	user_tb = gtk_toggle_button_new_with_label ("Shift");
	gtk_fixed_put (GTK_FIXED (conf_f), user_tb, 120, 20);
  	gtk_signal_connect (GTK_OBJECT (user_tb), "toggled", GTK_SIGNAL_FUNC (user_tb_toggled), NULL);

	user_b = gtk_button_new_with_label ("Save");
	gtk_fixed_put (GTK_FIXED (conf_f), user_b, 200, 20);
  	gtk_signal_connect (GTK_OBJECT (user_b), "clicked", GTK_SIGNAL_FUNC (user_b_clicked), NULL);
	
    user_key_t = gtk_table_new (6, 45, TRUE);
	gtk_fixed_put (GTK_FIXED (conf_f), user_key_t, 0, 50);
	gtk_widget_set_usize (user_key_t, 500, 180);

	for (gi_dog = 0;  gi_dog < gi_total_key;  gi_dog++)
	{
		key[gi_dog].e = gtk_entry_new ();
	   	gtk_table_attach_defaults (GTK_TABLE (user_key_t),
			key[gi_dog].e, key[gi_dog].left, key[gi_dog].right, key[gi_dog].top, key[gi_dog].bottom);
		gtk_entry_set_text (GTK_ENTRY (key[gi_dog].e), key[gi_dog].lang[1].v);
		if (key[gi_dog].flag == 0)
    		gtk_signal_connect (GTK_OBJECT (key[gi_dog].e), "changed", GTK_SIGNAL_FUNC (user_e_changed), &key[gi_dog]);
		else
			gtk_widget_set_sensitive (key[gi_dog].e, FALSE);
	}
}



void key_press_shift ()
{
	gint gi_dog;
	GString *gs_lang;

	for (gi_dog = 0;  gi_dog < gi_total_key;  gi_dog++)
	{
		gs_lang = g_string_new (key[gi_dog].lang[0].w);
		if (gi_current_lang != 0)
			if (strcmp (gs_lang->str, key[gi_dog].lang[gi_current_lang].w))
			{
				gs_lang = g_string_append (gs_lang, "\n");
				gs_lang = g_string_append (gs_lang, key[gi_dog].lang[gi_current_lang].w);
			}
		gtk_label_set_text (GTK_LABEL (key[gi_dog].l), gs_lang->str);
		g_string_free (gs_lang, TRUE);
	}
}



void key_release_shift ()
{
	gint gi_dog;
	GString *gs_lang;

	for (gi_dog = 0;  gi_dog < gi_total_key;  gi_dog++)
	{
		gs_lang = g_string_new (key[gi_dog].lang[0].v);
		if (gi_current_lang != 0)
			if (strcmp (gs_lang->str, key[gi_dog].lang[gi_current_lang].v))
			{
				gs_lang = g_string_append (gs_lang, "\n");
				gs_lang = g_string_append (gs_lang, key[gi_dog].lang[gi_current_lang].v);
			}
		gtk_label_set_text (GTK_LABEL (key[gi_dog].l), gs_lang->str);
		g_string_free (gs_lang, TRUE);
	}
}



GtkWidget* create_character_hb ()
{
	GtkWidget *character_hb; // handle box
	GtkWidget *conf_f; // fixed
	GtkWidget *lang_f; // frame
	GtkWidget *lang_om; // option menu
	GtkWidget *lang_m; // menu
	GtkWidget *lang_mi; // menu item
	GString *gs_lang[GTYPING_SUPPORT_LANG];
	gint gi_dog;

	character_hb = gtk_handle_box_new ();

	conf_f = gtk_fixed_new ();
	gtk_container_add (GTK_CONTAINER (character_hb), conf_f);
	gtk_container_set_border_width  (GTK_CONTAINER (conf_f), 10);

	lang_f = gtk_frame_new ("Keyboard Type");
	gtk_fixed_put (GTK_FIXED (conf_f), lang_f, 5, 5);

	lang_om = gtk_option_menu_new ();
	gtk_container_add (GTK_CONTAINER (lang_f), lang_om);

	lang_m = gtk_menu_new ();
	gtk_option_menu_set_menu (GTK_OPTION_MENU (lang_om), lang_m);

	gs_lang[0] = g_string_new ("English");
	gs_lang[1] = g_string_new ("User");
	gs_lang[2] = g_string_new ("Hangul_2");
	gs_lang[3] = g_string_new ("Hangul_3_390");
	gs_lang[4] = g_string_new ("Hangul_3_final");

	for (gi_dog=0;gi_dog<GTYPING_SUPPORT_LANG;gi_dog++)
	{
		lang_mi = gtk_menu_item_new_with_label (gs_lang[gi_dog]->str);
		gtk_signal_connect (GTK_OBJECT (lang_mi), "activate", GTK_SIGNAL_FUNC (lang_mi_activate), (gpointer) gi_dog);
		gtk_menu_append (GTK_MENU (lang_m), lang_mi);

		g_string_prepend (gs_lang[gi_dog], "./keys/");
		key_load_lang (gs_lang[gi_dog]->str, gi_dog);
		g_string_free (gs_lang[gi_dog], TRUE);
	}

	key_set_user_key (conf_f);

	return character_hb;
}



GtkWidget* create_character_v ()
{
	GtkWidget *character_v; // vbox
	GtkWidget *character_l; // label
	GtkWidget *character_hb; // handle box

	character_v = gtk_vbox_new (FALSE, 0);
	character_l = gtk_label_new ("character");

	character_t = gtk_text_new (NULL, NULL);
	gtk_box_pack_start (GTK_BOX (character_v), character_t, TRUE, TRUE, 0);
	GTK_WIDGET_UNSET_FLAGS (GTK_WIDGET (character_t), GTK_CAN_FOCUS);

    keyboard_t = gtk_table_new (6, 45, TRUE);
	gtk_box_pack_start (GTK_BOX (character_v), keyboard_t, FALSE, FALSE, 0);

	key_load_file ();
	key_init (gtk_widget_get_default_style());

	character_hb = create_character_hb ();
	gtk_box_pack_start (GTK_BOX (character_v), character_hb, FALSE, FALSE, 0);
	gtk_handle_box_set_handle_position (GTK_HANDLE_BOX (character_hb), GTK_POS_RIGHT);

  	gtk_widget_show_all (character_v);
    gtk_widget_hide (user_key_t);
    gtk_widget_hide (user_tb);
    gtk_widget_hide (user_b);

	return character_v;
}
