/*********************
game.c                
	by logotherapy
*********************/
#include "callbacks.h"



game_ts game[GTYPING_GAME_UNIT];
gchar *gc_game_text[GTYPING_GAME_UNIT] = {
	"gnu", "gnome", "gtk", "gtyping", "logotherapy", };



gint game_timeout (gpointer data)
{
	gint gi_dog;

	for (gi_dog=0;gi_dog<GTYPING_GAME_UNIT;gi_dog++)
	{
		switch (game[gi_dog].state)
		{
			case GTYPING_STOP:
				break;
			case GTYPING_MOVE:
				gnome_canvas_item_move (game[gi_dog].gci, 0, 10);
				break;
		}
	}

	return TRUE;
}



void game_init (GnomeCanvasGroup *game_gcg)
{
	gint gi_dog;

	for (gi_dog=0;gi_dog<GTYPING_GAME_UNIT;gi_dog++)
	{
		if (gc_game_text[gi_dog]!=NULL)
			strcpy (game[gi_dog].text, gc_game_text[gi_dog]);
		else 
			strcpy (game[gi_dog].text, "");

		game[gi_dog].x = gi_dog*50;
		game[gi_dog].y = 50;
		game[gi_dog].state = GTYPING_STOP;

		game[gi_dog].gci = gnome_canvas_item_new (game_gcg, gnome_canvas_text_get_type(),
			"text", game[gi_dog].text,
			"x", game[gi_dog].x,
			"y", game[gi_dog].y,
			"font_gdk", gdk_fontset_load ("-adobe-helvetica-medium-r-normal--*-120-*-*-*-*-*-*"),
			"anchor", GTK_ANCHOR_NORTH_WEST,
			"fill_color", "black",
			NULL);
	}
}



GtkWidget* create_game_table ()
{

	GtkWidget *game_table; // table
	GtkWidget *game_e; // entry
	GtkWidget *game_gc; // gnome canvas
	GnomeCanvasGroup *game_gcg; // gnome canvas group
	gdouble gd_game_height;
	gdouble gd_game_width;

    game_table = gtk_table_new (3, 2, FALSE);

	game_e = gtk_entry_new ();
	gtk_table_attach (GTK_TABLE (game_table), game_e, 0, 1, 1, 2, 0, 0, 0, 0);
	gtk_signal_connect (GTK_OBJECT (game_e), "activate", GTK_SIGNAL_FUNC (game_e_activate), NULL);

	gtk_widget_push_visual (gdk_imlib_get_visual ());
	gtk_widget_push_colormap (gdk_imlib_get_colormap ());

	gd_game_height = 600;
	gd_game_width = 400;

	game_gc = gnome_canvas_new ();
	gtk_table_attach (GTK_TABLE (game_table), game_gc, 0, 3, 0, 1, GTK_EXPAND|GTK_FILL, GTK_EXPAND|GTK_FILL, 0, 0);
	gnome_canvas_set_pixels_per_unit(GNOME_CANVAS (game_gc), 1);
	gnome_canvas_set_scroll_region(GNOME_CANVAS (game_gc), 0.0, 0.0, gd_game_height, gd_game_width);

	game_gcg = gnome_canvas_root (GNOME_CANVAS (game_gc));

	game_init (game_gcg);

	gtk_widget_pop_colormap ();
	gtk_widget_pop_visual ();

	gtk_widget_show_all (game_table);

	gtk_timeout_add(1000, game_timeout, NULL);

	return game_table;
}
