/*********************
main.c                
	by logotherapy
*********************/
#include "callbacks.h"



void create_main_w ()
{
	GtkWidget *main_w; // window
	GtkWidget *main_n; // notebook
	GtkWidget *character_l; // label
	GtkWidget *text_l; // label
	GtkWidget *game_l; // label
	GtkWidget *about_l; // label

	main_w = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_container_set_border_width  (GTK_CONTAINER (main_w), 10);
	gtk_window_set_policy (GTK_WINDOW (main_w), TRUE, TRUE, FALSE);
    gtk_widget_set_events (main_w, GDK_KEY_RELEASE_MASK);
	gtk_signal_connect (GTK_OBJECT (main_w), "delete-event", GTK_SIGNAL_FUNC (main_w_delete_event), NULL);
    gtk_signal_connect (GTK_OBJECT (main_w), "key_press_event", GTK_SIGNAL_FUNC (main_w_key_press_event), NULL);
    gtk_signal_connect (GTK_OBJECT (main_w), "key_release_event", GTK_SIGNAL_FUNC (main_w_key_release_event), NULL);

	main_n = gtk_notebook_new ();
	gtk_container_add (GTK_CONTAINER (main_w), main_n);
	gtk_notebook_set_tab_border (GTK_NOTEBOOK (main_n), 10);
	GTK_WIDGET_UNSET_FLAGS (GTK_WIDGET (main_n), GTK_CAN_FOCUS);

	character_l = gtk_label_new ("character");
	gtk_notebook_append_page (GTK_NOTEBOOK (main_n), create_character_v (), character_l);

	text_l = gtk_label_new ("text");
	gtk_notebook_append_page (GTK_NOTEBOOK (main_n), create_text_table (), text_l);

	game_l = gtk_label_new ("game");
	gtk_notebook_append_page (GTK_NOTEBOOK (main_n), create_game_table (), game_l);

	about_l = gtk_label_new ("about");
	gtk_notebook_append_page (GTK_NOTEBOOK (main_n), create_about_l (), about_l);

	gtk_widget_show (main_n);
	gtk_widget_show (main_w);
}



gint main (int argc, char *argv[])
{
	gtk_init (&argc, &argv);

	gdk_imlib_init();

	create_main_w ();

	key_release_shift();

	gtk_main ();
	return FALSE;
}
