/*********************
text.c                
	by logotherapy
*********************/
#include "callbacks.h"



/*********************
GLOBAL VARIABLE       
*********************/
GtkWidget *text_sb; // spin button
GtkObject *text_a; // adjustment
GtkWidget *text_t[GTYPING_TEXT_PAGE]; // text
GtkWidget *text_e[GTYPING_TEXT_PAGE]; // entry
GtkWidget *text_log_l; // label
GtkWidget *text_log_c; // clock
GtkWidget *text_l[GTYPING_TEXT_PAGE]; // label
GtkWidget *text_c[GTYPING_TEXT_PAGE]; // clock
GtkWidget *text_table; // table
GString *gs_text[GTYPING_TEXT_LINE_MAX];
gint gi_total_line;
gint gi_current_line;



void text_te_init ()
{
	gint gi_dog;
	gchar gc_dog[GTYPING_TEXT_PAGE][4];

	for (gi_dog=0;gi_dog<GTYPING_TEXT_PAGE;gi_dog++)
	{
		gtk_text_set_point (GTK_TEXT (text_t[gi_dog]), 0);
		gtk_text_forward_delete (GTK_TEXT (text_t[gi_dog]), gtk_text_get_length (GTK_TEXT (text_t[gi_dog])) );

		if (gi_dog==GTYPING_TEXT_PAGE-1)
		{
			gtk_widget_destroy (text_e[gi_dog]);
			text_e[gi_dog] = gtk_entry_new ();
			gtk_table_attach (GTK_TABLE (text_table), text_e[gi_dog], 0, 5, 3+3*gi_dog, 4+3*gi_dog, GTK_EXPAND|GTK_FILL, 0, 0, 0);
			gtk_signal_connect (GTK_OBJECT (text_e[gi_dog]), "insert_text", GTK_SIGNAL_FUNC (text_e_insert_text), GINT_TO_POINTER (gi_dog));
			gtk_signal_connect (GTK_OBJECT (text_e[gi_dog]), "delete_text", GTK_SIGNAL_FUNC (text_e_delete_text), GINT_TO_POINTER (gi_dog));
			gtk_widget_set_style (GTK_WIDGET (text_e[gi_dog]), gtk_widget_get_style (text_t[gi_dog]));
			gtk_widget_show (text_e[gi_dog]);
		}
		else
			gtk_entry_set_text (GTK_ENTRY (text_e[gi_dog]), "");

		if (gi_current_line+gi_dog<gi_total_line)
		{
			if (gs_text[gi_current_line+gi_dog]->len >= 1)
			{
				gtk_text_insert (GTK_TEXT (text_t[gi_dog]), NULL, NULL, NULL,
					   gs_text[gi_current_line+gi_dog]->str, gs_text[gi_current_line+gi_dog]->len);
				gtk_entry_set_max_length (GTK_ENTRY (text_e[gi_dog]), gs_text[gi_current_line+gi_dog]->len);

				sprintf (gc_dog[gi_dog], "%d", gs_text[gi_current_line+gi_dog]->len);
				gtk_label_set (GTK_LABEL (text_l[gi_dog]), gc_dog[gi_dog]);

				GTK_WIDGET_SET_FLAGS (text_e[gi_dog], GTK_CAN_FOCUS);
				gtk_clock_stop (GTK_CLOCK (text_c[gi_dog]));
				gtk_clock_set_seconds (GTK_CLOCK (text_c[gi_dog]), 0);
				gtk_widget_show (text_c[gi_dog]);
			}
		}
		else
		{
			gtk_label_set (GTK_LABEL (text_l[gi_dog]), "");

			GTK_WIDGET_UNSET_FLAGS (text_e[gi_dog], GTK_CAN_FOCUS);
			gtk_widget_hide (text_c[gi_dog]);
		}
	}

}



GtkWidget* create_text_table ()
{
	GtkWidget *text_gfe; // gnome file entry
	GtkWidget *text_gfp; // gnome font picker
	GtkTooltips *text_gfp_t; // tooltips
	GtkWidget *text_ce; // combo entry
	GtkTooltips *text_sb_t; // tooltips
	GtkRequisition text_r; // requisition
	gint gi_dog;

    text_table = gtk_table_new (5, 2+GTYPING_TEXT_PAGE*3, FALSE);

	text_gfe = gnome_file_entry_new (NULL, "Load Text File");
	gtk_table_attach (GTK_TABLE (text_table), text_gfe, 0, 1, 0, 1, 0, 0, 0, 0);
	// table, child, left_attach, right_attach, top_attach, bottom_attach, xoptions, yoptions, xpadding, ypadding
	GTK_WIDGET_UNSET_FLAGS (text_gfe, GTK_CAN_FOCUS);
	
	text_ce = gnome_file_entry_gtk_entry (GNOME_FILE_ENTRY (text_gfe));
	gtk_signal_connect (GTK_OBJECT (text_ce), "activate", GTK_SIGNAL_FUNC (text_ce_activate), NULL);
	GTK_WIDGET_UNSET_FLAGS (text_ce, GTK_CAN_FOCUS);

	text_gfp = gnome_font_picker_new ();
	gtk_table_attach (GTK_TABLE (text_table), text_gfp, 1, 2, 0, 1, 0, 0, 0, 0);
	gtk_signal_connect (GTK_OBJECT (text_gfp), "font_set", GTK_SIGNAL_FUNC (text_gfp_font_set), NULL);

	text_gfp_t = gtk_tooltips_new ();
	gtk_tooltips_set_tip (text_gfp_t, text_gfp, "Font", NULL);

	text_a = gtk_adjustment_new (0, 0, 0, 0, 0, 0);
	// value, lower, upper, step_increment, page_increment, page_size

	text_sb = gtk_spin_button_new (GTK_ADJUSTMENT (text_a), 0, 0);
	gtk_table_attach (GTK_TABLE (text_table), text_sb, 2, 3, 0, 1, 0, 0, 0, 0);
	gtk_spin_button_set_update_policy (GTK_SPIN_BUTTON (text_sb), GTK_UPDATE_IF_VALID);
	gtk_signal_connect (GTK_OBJECT (text_a), "value_changed", GTK_SIGNAL_FUNC (text_a_value_changed), text_sb);

	text_sb_t = gtk_tooltips_new ();
	gtk_tooltips_set_tip (text_sb_t, text_sb, "Up, Down, PageUp, PageDown", NULL);

	text_log_l = gtk_label_new ("");
	gtk_table_attach (GTK_TABLE (text_table), text_log_l, 3, 4, 0, 1, 0, 0, 0, 0);

	text_log_c = gtk_clock_new (GTK_CLOCK_INCREASING);
	gtk_table_attach (GTK_TABLE (text_table), text_log_c, 4, 5, 0, 1, 0, 0, 0, 0);

	for (gi_dog=0;gi_dog<GTYPING_TEXT_PAGE;gi_dog++)
	{
		text_l[gi_dog] = gtk_label_new ("");
		gtk_table_attach (GTK_TABLE (text_table), text_l[gi_dog], 3, 4, 1+3*gi_dog, 2+3*gi_dog, 0, 0, 0, 0);

		text_c[gi_dog] = gtk_clock_new (GTK_CLOCK_INCREASING);
		gtk_table_attach (GTK_TABLE (text_table), text_c[gi_dog], 4, 5, 1+3*gi_dog, 2+3*gi_dog, 0, 0, 0, 0);
		
		text_t[gi_dog] = gtk_text_new (NULL, NULL);
		gtk_widget_ref (text_t[gi_dog]);
		gtk_table_attach (GTK_TABLE (text_table), text_t[gi_dog], 0, 5, 2+3*gi_dog, 3+3*gi_dog, GTK_EXPAND|GTK_FILL, 0, 0, 0);
		gtk_text_set_line_wrap (GTK_TEXT (text_t[gi_dog]), FALSE);

		text_e[gi_dog] = gtk_entry_new ();
		gtk_table_attach (GTK_TABLE (text_table), text_e[gi_dog], 0, 5, 3+3*gi_dog, 4+3*gi_dog, GTK_EXPAND|GTK_FILL, 0, 0, 0);
		gtk_signal_connect (GTK_OBJECT (text_e[gi_dog]), "insert_text", GTK_SIGNAL_FUNC (text_e_insert_text), GINT_TO_POINTER (gi_dog));
		gtk_signal_connect (GTK_OBJECT (text_e[gi_dog]), "delete_text", GTK_SIGNAL_FUNC (text_e_delete_text), GINT_TO_POINTER (gi_dog));

		gtk_widget_size_request (text_e[gi_dog], &text_r);
		gtk_widget_set_usize (text_t[gi_dog], text_r.width, text_r.height);
		GTK_WIDGET_UNSET_FLAGS (GTK_WIDGET (text_t[gi_dog]), GTK_CAN_FOCUS);
	}

	gtk_widget_show_all (text_table);
	for (gi_dog=0;gi_dog<GTYPING_TEXT_PAGE;gi_dog++)
		gtk_widget_hide (text_c[gi_dog]);
	return text_table;
}
